//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
#include "bbcreaVtkClipPolyData.h"
#include "bbcreaVtkPackage.h"

#include "vtkExtractPoints.h"
#include "vtkClipPolyData.h"

namespace bbcreaVtk
{

BBTK_ADD_BLACK_BOX_TO_PACKAGE(creaVtk,ClipPolyData)
BBTK_BLACK_BOX_IMPLEMENTATION(ClipPolyData,bbtk::AtomicBlackBox);
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void ClipPolyData::Process()
{

// THE MAIN PROCESSING METHOD BODY
//   Here we simply set the input 'In' value to the output 'Out'
//   And print out the output value
// INPUT/OUTPUT ACCESSORS ARE OF THE FORM :
//    void bbSet{Input|Output}NAME(const TYPE&)
//    const TYPE& bbGet{Input|Output}NAME() const 
//    Where :
//    * NAME is the name of the input/output
//      (the one provided in the attribute 'name' of the tag 'input')
//    * TYPE is the C++ type of the input/output
//      (the one provided in the attribute 'type' of the tag 'input')

//    bbSetOutputOut( bbGetInputIn() );
//    std::cout << "Output value = " <<bbGetOutputOut() << std::endl;
  
	if ((bbGetInputIn()!=NULL)  && (bbGetInputImplicitFunction()!=NULL) )
	{
		if (bbGetInputType()==0)
		{
			vtkClipPolyData *clip = vtkClipPolyData::New();
			clip->SetInputData( bbGetInputIn() );
			clip->SetClipFunction( bbGetInputImplicitFunction() );
			clip->GenerateClipScalarsOn();
	  		clip->GenerateClippedOutputOff();
			if (bbGetInputInside()==true)
			{
				clip->InsideOutOn();
			} else {
				clip->InsideOutOff();
			}
			clip->Update();
			bbSetOutputOut( clip->GetOutput() );
		} // Type 0
		if (bbGetInputType()==1)
		{
			vtkExtractPoints *clip = vtkExtractPoints::New();
			clip->SetInputData( bbGetInputIn() );
			clip->SetImplicitFunction( bbGetInputImplicitFunction() );
			if (bbGetInputInside()==true)
			{
				clip->ExtractInsideOn();
			} else {
				clip->ExtractInsideOff();
			}
			clip->Update();
			bbSetOutputOut( clip->GetOutput() );
		} // type 1
	} else {
		printf("EED Warnning!  ClipPolyData::Process  In or ImplicitFunction is EMPTY\n");
	} // if In ImplicitFunction != NULL

}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void ClipPolyData::bbUserSetDefaultValues()
{

//  SET HERE THE DEFAULT INPUT/OUTPUT VALUES OF YOUR BOX 
//    Here we initialize the input 'In' to 0
   bbSetInputIn( NULL );
   bbSetInputType( 0 );
   bbSetInputInside( true );
   bbSetInputImplicitFunction( NULL );
  
}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void ClipPolyData::bbUserInitializeProcessing()
{

//  THE INITIALIZATION METHOD BODY :
//    Here does nothing 
//    but this is where you should allocate the internal/output pointers 
//    if any 

  
}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void ClipPolyData::bbUserFinalizeProcessing()
{

//  THE FINALIZATION METHOD BODY :
//    Here does nothing 
//    but this is where you should desallocate the internal/output pointers 
//    if any
  
}
}
// EO namespace bbcreaVtk


