//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
#include "bbcreaVtkActor.h"
#include "bbcreaVtkPackage.h"
#include "vtkProperty.h"


namespace bbcreaVtk
{

BBTK_ADD_BLACK_BOX_TO_PACKAGE(creaVtk,Actor)
BBTK_BLACK_BOX_IMPLEMENTATION(Actor,bbtk::AtomicBlackBox);
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void Actor::Process()
{

// THE MAIN PROCESSING METHOD BODY
//   Here we simply set the input 'In' value to the output 'Out'
//   And print out the output value
// INPUT/OUTPUT ACCESSORS ARE OF THE FORM :
//    void bbSet{Input|Output}NAME(const TYPE&)
//    const TYPE& bbGet{Input|Output}NAME() const 
//    Where :
//    * NAME is the name of the input/output
//      (the one provided in the attribute 'name' of the tag 'input')
//    * TYPE is the C++ type of the input/output
//      (the one provided in the attribute 'type' of the tag 'input')

//    bbSetOutputOut( bbGetInputIn() );
//    std::cout << "Output value = " <<bbGetOutputOut() << std::endl;
 

	if (bbGetInputIn()!=NULL)
	{
		vtkProp3D* vtkprop3D=bbGetInputIn();
		std::string className = vtkprop3D->GetClassName();
		std::string wantedClass = "vtkOpenGLActor";
		if(className == wantedClass)
		{
			vtkActor *vtkactor=((vtkActor*)vtkprop3D);
			vtkactor->GetProperty()->SetOpacity( bbGetInputOpacity() );
			vtkactor->GetProperty()->SetLineWidth( bbGetInputLineWidth() );
			double r = bbGetInputColor()[0];
			double g = bbGetInputColor()[1];
			double b = bbGetInputColor()[2];
			vtkactor->GetProperty()->SetColor( r,g,b );
		}
		 if ( bbGetInputTransform()!=NULL )
		 {
		    vtkprop3D->SetUserTransform( bbGetInputTransform() );
		 }

        // bbSetOutputOut( vtkactor );
        // Interface Update

		if ((bbGetInputRenderer()!=NULL) && ( backActive!=bbGetInputActive() ))
		{
			if (bbGetInputActive()==true )
		 	{
		   		bbGetInputRenderer()->AddActor( vtkprop3D );
		 	}  else {
		   		bbGetInputRenderer()->RemoveActor( vtkprop3D );
		 	}  //if Active
			backActive=bbGetInputActive();
	 	} // if Renderer
	}// bbGetInputIn

}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void Actor::bbUserSetDefaultValues()
{

//  SET HERE THE DEFAULT INPUT/OUTPUT VALUES OF YOUR BOX 
//    Here we initialize the input 'In' to 0

	std::vector<double> color;
	color.push_back(1);
	color.push_back(0);
	color.push_back(0);
	bbSetInputActive( false );
	backActive=bbGetInputActive();
	bbSetInputIn( NULL );
	bbSetInputOpacity( 1 );
	bbSetInputLineWidth( 0.5 );
	bbSetInputRenderer( NULL );
	bbSetInputColor( color );

}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void Actor::bbUserInitializeProcessing()
{

//  THE INITIALIZATION METHOD BODY :
//    Here does nothing 
//    but this is where you should allocate the internal/output pointers 
//    if any 

  
}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void Actor::bbUserFinalizeProcessing()
{

//  THE FINALIZATION METHOD BODY :
//    Here does nothing 
//    but this is where you should desallocate the internal/output pointers 
//    if any
  
}
}
// EO namespace bbcreaVtk


